//BLOBBY VOLLEY - TI68k C Source File
//adaptation du jeu PC pour calculatrices TI92+(HW1/HW2)
//seul le nom a t repris et tous les graphismes et les sources sont de la j2t
//sous license GNU GPL - voir license.txt (see license.txt for more details about copyright)
//vous pouvez reprendre tout ou partie de ce code pour le modifier et/ou l'intgrer a vos programmes
//copyleft (C) la janjan2team(j2t) - [http://www.j2t.fr.st/]
//programm par janjan2/ben [janjan2@laposte.net] sous TIGCC [http://tigcc.ticalc.org]
//VERSION BETA n2 - 9 janvier 2002

//VERSION 92plus UNIQUEMENT!!!!!!!!

#define USE_TI89              // Produce .89z File
#define USE_TI92PLUS          // Produce .9xz File

short _ti89,_ti92plus;

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define SAVE_SCREEN           // Save/Restore LCD Contents
#include <tigcclib.h>         // Include All Header Files (tigclib)
#include "rowkeys.h"					// librairie de lecture du clavier en bas niveau de la j2t
#include "sprites.h"					// sprites: fond, perso, balle
#include "about.h"						// texte d'aide
#define MAX_VY   12
#define START_Y  97

#define SIGNE(a) (a>0?1:0)

//VARIABLES GLOBALES
//joueur
typedef struct player{
	short x,y,vy,vx,minx,maxx,perspr,tc,win,cx,cy;
}PLAYER;
PLAYER one,two;
//balle
short bx,by,bvx,bvy,bcx,bcy;

//ecran virtuel
char *virt_0;
char *virt_1;
	
//sprites joueur
short sprdec[4]={0,90,180,90};

//ROUTINE DE SPRITE COPIEE SUR EXTGRAPH :: http://tict.ticalc.org/ (C) la ti chess team
//cette fct sera remplace dans une prochaine version
//!!!!!!!!ATTENTION, LA LICENSE NE S'APPLIQUE PAS A CETTE FONCTION!!!!!!!!
void sprite(short x,short y,short h,unsigned char* sprite,unsigned char* mask,short bytewidth,void* dest) {
    register unsigned char* addr  = ((unsigned char*)dest)+((y<<5)-(y<<1)+(x>>3));
    register unsigned short shift1 = x & 7;
    register unsigned short shift2;
    register unsigned short lineoffset = 30-bytewidth;
    register          short loop;
    register unsigned char  startmask;
    register unsigned char  endmask;

    if (shift1) {
        shift2 = 8 - shift1;
        startmask = 0xff << shift2;
        endmask   = 0xff >> shift1;
        for (;h;h--,addr+=lineoffset) {
            *addr   &= ((*mask) >> shift1) | startmask;
            *addr++ |= *sprite >> shift1;
            for (loop=1;loop<bytewidth;loop++) {
               unsigned char val = (*mask++) << shift2;
               *addr   &= val | ((*mask) >> shift1);
               *addr   |= ((*sprite++) << shift2);
               *addr++ |= (*sprite >> shift1);
            }
            *addr &= ((*mask++) << shift2) | endmask;
            *addr |= (*sprite++ << shift2);
        }
    }
    else {
        for (;h;h--,addr+=lineoffset) {
            for (loop=0;loop<bytewidth;loop++) {
                *addr   &= *mask++;
                *addr++ |= *sprite++;
            }
        }
    }
}

//ROUTINE DE HOTSPOT
char hotspot(short x0,short x1,short y0,short y1,short checkx,short checky)
{if(checkx>=x0&&checkx<=x1&&checky>=y0&&checky<=y1)return 1;else return 0;}

//ROUTINE DE SCROLL
void about(char **text,int lines)
{
  int i=0,j,tempo,y=8;
  //affiche la barre de titre dans les 2 plans
  memset(GetPlane(0),0,3840);
  memcpy(GetPlane(0),fond_0,210);
  memset(GetPlane(1),0,3840);
  memcpy(GetPlane(1),fond_0,210);
  //trace le cadre
  PortSet(GetPlane(0),239,127);
  DrawPix(2,7,A_NORMAL);
	DrawPix(237,7,A_NORMAL);
	DrawLine(1,7,1,127,A_NORMAL);
  DrawLine(238,7,238,127,A_NORMAL);
  DrawLine(2,127,237,127,A_NORMAL);
  PortSet(GetPlane(1),239,127);
  DrawPix(2,7,A_NORMAL);
	DrawPix(237,7,A_NORMAL);
	DrawLine(1,7,1,127,A_NORMAL);
  DrawLine(238,7,238,127,A_NORMAL);
  DrawLine(2,127,237,127,A_NORMAL);
  memset(virt_1,0,3840);
  PortSet(virt_1,239,127);
  FontSetSys(F_6x8);
  //boucle de scrolling
	while(!_92P_KEY_ENTER)
	{
	  //les lignes commenant par un '#' sont en 8x10, les autres en 6x8
	  if((*text[i])=='#'){FontSetSys(F_8x10);DrawStr(120-((strlen(text[i])*8-1)/2),115,text[i]+1,A_NORMAL);y=10;}
	  else{FontSetSys(F_6x8);DrawStr(120-((strlen(text[i])*6)/2),115,text[i],A_NORMAL);y=8;}
		for(j=0;j<y;j++)
		 {
		 	 memmove(virt_1,virt_1+30,3810);
			 DrawLine(1,0,1,127,A_NORMAL);
 			 DrawLine(238,0,238,127,A_NORMAL);
 			 //appariton progresive
		 	 memcpy(GetPlane(1)+600,virt_1+300,2880);
		 	 memcpy(GetPlane(0)+300,virt_1,300);
		 	 memcpy(GetPlane(0)+900,virt_1+600,2280);
		 	 memcpy(GetPlane(0)+3480,virt_1+3180,300);
		 	 //boucle de tempo
		 	 for(tempo=0;(!_92P_KEY_ENTER)&&(tempo<500);tempo++){tempo++;tempo--;}
		 }
		i++;
		if(i==lines)i=0;
	}
}

//ROUTINE PRINCIPALE (L O A COMMENCE  TRE POLANT)
void _main(void)
{
//DECLARATION DES VARIABLES
	//variables d'algorithme
	short i,tour=0,bal=0,engage=0,sol=0,angle,*pvtab,vtab[]={
		1,-5,3,-5,6,-7,7,-7,9,-2,	
		2,8,7,7,9,3,9,3,8,8,	
		-1,-5,-3,-5,-6,-7,-7,-7,-9,-2,	
		-2,8,-7,7,-9,3,-9,3,-8,8
		};
	char *buffer="0000";
	//handles d'interruptions
	INT_HANDLER save_int_1;
	INT_HANDLER save_int_5;
	INT_HANDLER autoint_bkp;
	//supression des interruptions [ON] et 5
	autoint_bkp=GetIntVec(AUTO_INT_6);
	SetIntVec(AUTO_INT_6,DUMMY_HANDLER);
	save_int_1=GetIntVec(AUTO_INT_1);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	save_int_5=GetIntVec(AUTO_INT_5);
	SetIntVec(AUTO_INT_5,DUMMY_HANDLER);	
	//activation des niveaux de gris
	GrayOn();
//INITIALISATION DES VARIABLES GLOBALES & DU JEU
	//ecran
	virt_0=malloc(3840);
	virt_1=malloc(3840);
	//parties
	two.win=0,one.win=0;
newgame://label de nouvelle partie
	engage=0;
	sol=0;
	//paramtres initials du joueur
	one.minx=0;one.maxx=118-24;
	two.minx=122;two.maxx=240-24;
	one.perspr=0;two.perspr=0;
	//initialisation des variables joueur
	one.x=50;one.y=START_Y;one.vy=0;one.vx=0;
	two.x=170;two.y=START_Y;two.vy=0;two.vx=0;
	one.tc=0;two.tc=0;
	//initialisation de la balle
	if(one.win<two.win)bx=175;
	if(one.win>two.win)bx=55;
	if(one.win==two.win){bx=(random(2)?55:175);}
	by=50;bvx=0;bvy=0;
	//affichage du fond
	memcpy(GetPlane(1),fond_1,3840);
	memcpy(GetPlane(0),fond_0,3840);
	
//BOUCLE DE JEU
	while(!_92P_KEY_ESC)
	{
	//INITIALISATION
		//effaage de l'ecran
		memcpy(virt_0,fond_0,3840);
		memcpy(virt_1,fond_1,3840);
	//PARAMETRES JOUEURS
		//PREMIER JOUEUR
		//lecture des touches
		one.vx=0;
		if(_92P_KEY_ALPHAX&&(!one.vy))one.vy=MAX_VY;
		if(_92P_KEY_DIAMOND&&one.x>one.minx){one.x-=4;one.vx=-2;if(one.y==START_Y&&one.perspr==0)one.perspr=3;}
		if(_92P_KEY_STO&&one.x<one.maxx){one.x+=4;one.vx=2;if(one.y==START_Y&&one.perspr==0)one.perspr=3;}
		//modification des paramtres du joueur
		if(one.vy>=2)one.vy--;
		if(one.vy==1)one.vy=-1;
		if(one.vy<=-1)one.vy--;
		if(one.vy==-MAX_VY)one.vy=0;
		one.y-=one.vy;
		if(one.perspr)one.perspr--;
		//affichage du joueur
		sprite(one.x,one.y,30,perso_0+sprdec[one.perspr],perso_0+270+sprdec[one.perspr],3,virt_0);
		sprite(one.x,one.y,30,perso_1+sprdec[one.perspr],perso_1+270+sprdec[one.perspr],3,virt_1);
		//SECOND JOUEUR
		//lecture des touches
		two.vx=0;
		if(_92P_KEY_PAD2&&(!two.vy))two.vy=MAX_VY;
		if(_92P_KEY_PAD0&&two.x>two.minx){two.x-=4;two.vx=-2;if(two.y==START_Y&&two.perspr==0)two.perspr=3;}
		if(_92P_KEY_NEGAT&&two.x<two.maxx){two.x+=4;two.vx=2;if(two.y==START_Y&&two.perspr==0)two.perspr=3;}
		//modification des paramtres du joueur
		if(two.vy>=2)two.vy--;
		if(two.vy==1)two.vy=-1;
		if(two.vy<=-1)two.vy--;
		if(two.vy==-MAX_VY)two.vy=0;
		two.y-=two.vy;
		if(two.perspr)two.perspr--;
		//affichage du joueur
		sprite(two.x,two.y,30,perso_0+sprdec[two.perspr],perso_0+270+sprdec[two.perspr],3,virt_0);
		sprite(two.x,two.y,30,perso_1+sprdec[two.perspr],perso_1+270+sprdec[two.perspr],3,virt_1);
	//PARAMETRES BALLE
		//poids
		if(!tour)bvy-=2;
		//rebonds par rapport au sol
		if(by>=111&&bvy<0){if(bvy>=4)bvy=-(bvy>>1);else{by=112;bvy=0;}sol=1;}
		//rebonds par rapport aux murs
		if(bx<=0||bx>=224){bvy>>=1;bvx=-bvx;}
		if((bx+16)<117&&(bx+16+bvx)>117&&by>45)bvx=-bvx;
		if(bx>122&&(bx+bvx)<122&&by>45)bvx=-bvx;
		//suppression des touches de balle
		if((bx+16)<117&&(bx+16+bvx)>117&&by<45){one.tc=0;two.tc=0;}
		if(bx>122&&(bx+bvx)<122&&by<45){one.tc=0;two.tc=0;}
		//rebonds par rapport aux joueurs
		//essai sans hotspots multiples
		bcx=bx+8;bcy=by+8;
		one.cx=one.x+12;two.cx=two.x+12;
		one.cy=one.y+15;two.cy=two.y+15;
		if(hotspot(one.x-14,one.x+22,one.y-14,one.y+28,bx,by)&&(!sol))
		{
			angle=(int)abs(((float)(((float)one.cx-(float)bcx)/sqrt(((float)one.cx-(float)bcx)*((float)one.cx-(float)bcx)+((float)one.cy-(float)bcy)*((float)one.cy-(float)bcy)))*5));
		  pvtab=vtab;
		  if(one.cx>bcx)pvtab+=20;
		  if(one.cy>bcy)pvtab+=10;
		  bvx=pvtab[(angle<<1)];
		  bvy=pvtab[(angle<<1)+1];
		  engage=1;
		  //touche de balle
		  one.tc++;
		  //correction des vitesses
	  	if(SIGNE(bvx)&&(bvx<=one.vx))bvx=one.vx+1;
	  	if(!SIGNE(bvx)&&(bvx>=one.vx))bvx=one.vx-1;
	  	if(SIGNE(bvy)&&(bvy<=one.vy))bvy=one.vy+3;
	  	if(!SIGNE(bvy)&&(bvy>=one.vy))bvy=one.vy-3;
		}
		if(hotspot(two.x-14,two.x+22,two.y-14,two.y+28,bx,by)&&(!sol))
		{
			angle=(int)abs(((float)(((float)two.cx-(float)bcx)/sqrt(((float)two.cx-(float)bcx)*((float)two.cx-(float)bcx)+((float)two.cy-(float)bcy)*((float)two.cy-(float)bcy)))*5));
		  pvtab=vtab;
		  if(two.cx>bcx)pvtab+=20;
		  if(two.cy>bcy)pvtab+=10;
		  //modification des vitesses
		  bvx=pvtab[(angle<<1)];
		  bvy=pvtab[(angle<<1)+1];
		  engage=1;
		  //touche de balle
		  two.tc++;
		  //correction des vitesses
	  	if(SIGNE(bvx)&&(bvx<=two.vx))bvx=two.vx+2;
	  	if(!SIGNE(bvx)&&(bvx>=two.vx))bvx=two.vx-2;
	  	if(SIGNE(bvy)&&(bvy<=two.vy))bvy=two.vy+2;
	  	if(!SIGNE(bvy)&&(bvy>=two.vy))bvy=two.vy-2;
		}
		//application des vitesses
		if(engage)
		{
			by-=bvy;
			bx+=bvx;
		}
		//affichage de la balle
		if(by>=0&&by<=112&&bx>=0&&bx<=224)
		{
			sprite(bx,by,16,balle_0+(bal<<5),balle_0+256,2,virt_0);
			sprite(bx,by,16,balle_1+(bal<<5),balle_1+256,2,virt_1);
			//numero de sprite
			if(SIGNE(bvx))bal--;else bal++;
			if(bal==8)bal=0;
			if(bal==-1)bal=7;
		}
	//PARAMETRES JEU
		//lecture des touches
  	if(_92P_KEY_ADD){WAITKEYUP(_92P_KEY_ADD);OSContrastUp();}
		if(_92P_KEY_SUB){WAITKEYUP(_92P_KEY_SUB);OSContrastDn();}
    if(_92P_KEY_F1)about(about_text,67);
	  //affichage du score
	  FontSetSys(F_4x6);
	  PortSet(virt_1,239,1275);
	  sprintf(buffer,"%d",one.win);
	  DrawStr(70,1,buffer,A_XOR);
	  sprintf(buffer,"%d",two.win);
	  DrawStr(165,1,buffer,A_XOR);
	  PortRestore();
		//affichage
		memcpy(GetPlane(0),virt_0,3840);
		memcpy(GetPlane(1),virt_1,3840);
		//delai
		for(i=0;i<20000;i++){i--;i++;}
		//incrementation du tour
		tour++;
		if(tour)tour=0;
		//partie perdue/gagne
		if(by==112&&bx>=119){one.win++;goto newgame;}
		if(by==112&&bx<=119){two.win++;goto newgame;}
		if(one.tc==3){two.win++;goto newgame;}
		if(two.tc==3){one.win++;goto newgame;}
		//jeu perdu/gagn
		if(two.win==15||one.win==15)break;
		  
	}//FIN DE BOUCLE JEU
	
//FIN DU JEU
  //affichage du score
  sprite(97,23,45,score_1,score_m,6,GetPlane(1));
  sprite(97,23,45,score_0,score_m,6,GetPlane(0));
  FontSetSys(F_8x10);
	PortSet(GetPlane(1),239,127);
	sprintf(buffer,"%d",one.win);
	DrawStr(102,37,buffer,A_REPLACE);
	sprintf(buffer,"%d",two.win);
	DrawStr(125,37,buffer,A_REPLACE);
  PortSet(LCD_MEM,239,127);
  WAITKEYPRESSED(_92P_KEY_ENTER);
  //suppression des niveaux de gris
	GrayOff();
	//restauration des interruptions
	SetIntVec(AUTO_INT_5, save_int_5);
	SetIntVec(AUTO_INT_1, save_int_1);
	SetIntVec(AUTO_INT_6,autoint_bkp);	
	//liberation de la memoire
	free(virt_0);
	free(virt_1);
}
//PLUS DE CODE EN DESSOUS DE CETTE LIGNE


/*****HISTORIQUE DES VERSIONS*****

-[beta n2]-
-meilleure maniabilit
-meilleure gestion des collisions (completement refait)
-refonte des graphismes
-balle qui tourne et gelatine qui se dforme
-mise en forme propre du code pour distribution :-p

-[beta n1]-
-premiere beta publique
-mauvaise maniabilit

****EOF****/
